#include "metatask.h"
#include <Handle.h>
#include <f90cxx.h>
#include <stringutil.h>
#include <cstdio>

F90PROCDEF(void,task)(Routine t)
{
  task(t);
}

F90PROCDEF(Handle<Info::Task>,gettaskinfo)
  (const char * name,int nameLength)
{
  Info::Task* t=0;
  if (name) {
    string n=trim(string(name,nameLength));
    t=task(n.c_str());
  }
  else  t=Info::Task::current();

  return t;
}

F90PROCDEF(void,taskinfoname)
  (char * name,int nameLength,const Handle<Info::Task > & h)
{
  string n =trim(string(name,nameLength));

  Info::Task* t=h.addressOfObject();
  sprintf(name,"%-*.*s",nameLength,nameLength,t->name());
}

F90PROCDEF(void,taskinfoversion)
  (char * name,int nameLength,const Handle<Info::Task>& h)
{
  Info::Task* t=h.addressOfObject();
  sprintf(name,"%-*.*s",nameLength,nameLength,t->version());
}

F90PROCDEF(void,taskinfopackage)
  (char * name,int nameLength,const Handle<Info::Task>& h)
{
  Info::Task* t=h.addressOfObject();
  sprintf(name,"%-*.*s",nameLength,nameLength,t->package());
}

F90PROCDEF(void,taskinforelease)
  (char * name,int nameLength,const Handle<Info::Task>& h)
{
  Info::Task* t=h.addressOfObject();
  sprintf(name,"%-*.*s",nameLength,nameLength,t->release());
}
